import time
from datetime import datetime
from typing import List

from pydantic import BaseModel

from utils import get_uid


class Job(BaseModel):
    job_id: str = None  # 职位的唯一id
    job_name: str  # 职位名称
    job_sector: str  # 职位部门
    job_nature: int  # 职位性质
    job_priority: str  # 职位优先级
    owner_name: str  # 渠道
    principal: List[dict]  # 负责人
    patronn: List[dict]  # 协助人
    start_time: datetime = datetime.now()  # 开始招聘时间
    #end_time: datetime = None  # 结束招聘时间
    end_time: str = None  # 结束招聘时间
    function_type: str  # 职能类型
    filtering_rules: bool  # 是否使用筛选规则
    hiring_needs: bool  # 是否关联招聘需求
    auto_repeater: bool  # 是否自动转发
    cacsi_count: int = None  # 面试满意度反馈次数
    state: bool = None  # 职位招聘状态
    job_num: str = None  # 招聘人数
    education: int  # 学历要求
    job_rank: str  # 职位级别
    work_exp: int  # 工作经验
    report_obj: str  # 汇报对象
    min_money: int  # 薪资范围min
    max_money: int  # 薪资范围max
    requirement: str  # 需求描述
    hr_name: List[dict]  # 用人经理
    interview: List[dict]  # 面试官


class Jobs(BaseModel):
    job_id: str = None  # 职位的唯一id
    job_name: str = None  # 职位名称
    job_sector: str = None  # 职位部门
    job_nature: int = None  # 职位性质
    job_priority: str = None  # 职位优先级
    owner_name: str = None  # 渠道
    principal: List[dict] = None  # 负责人
    patronn: List[dict] = None  # 协助人
    #start_time: datetime = None  # 开始招聘时间
    start_time: str = None  # 开始招聘时间
    #end_time: datetime = None  # 结束招聘时间
    end_time: str = None  # 结束招聘时间
    function_type: str = None  # 职能类型
    filtering_rules: bool = None  # 是否使用筛选规则
    hiring_needs: bool = None  # 是否关联招聘需求
    auto_repeater: bool = None  # 是否自动转发
    cacsi_count: int = None  # 面试满意度反馈次数
    state: bool = None  # 职位招聘状态
    job_num: str = None  # 目标招聘人数
    now_job_num: int = None  # 实际招聘人数
    education: int = None  # 学历要求
    job_rank: str = None  # 职位级别
    work_exp: int = None  # 工作经验
    report_obj: str = None  # 汇报对象
    min_money: int = None  # 薪资范围min
    max_money: int = None  # 薪资范围max
    requirement: str = None  # 需求描述
    hr_name: List[dict] = None  # 用人经理
    interview: List[dict] = None  # 面试官


class Ins_Job(BaseModel):
    job_id: str = str(get_uid())  # 职位的唯一id
    job_name: str  # 职位名称
    job_sector: str  # 职位部门
    job_nature: int  # 职位性质
    job_priority: str = None  # 职位优先级
    owner_name: str = None  # 渠道
    principal: List[dict]  # 负责人
    patronn: List[dict]  # 协助人
    start_time: str  # 开始招聘时间
    function_type: str  # 职能类型
    filtering_rules: bool = None  # 是否使用筛选规则
    hiring_needs: bool = None  # 是否关联招聘需求
    auto_repeater: bool = None  # 是否自动转发
    cacsi_count: int = 0  # 面试满意度反馈次数
    state: bool  # 职位招聘状态
    job_num: str  # 目标招聘人数
    now_job_num: int = 0  # 实际招聘人数
    education: int  # 学历要求
    job_rank: str  # 职位级别
    work_exp: int  # 工作经验
    report_obj: str = None  # 汇报对象
    min_money: int  # 薪资范围min
    max_money: int  # 薪资范围max
    requirement: str  # 需求描述
    hr_name: List[dict]  # 用人经理
    interview: List[dict]  # 面试官
    end_time: str  # 结束招聘时间


class Find_job(BaseModel):
    job_id: str  # 职位的唯一id
